/******************************************************************************
ե롢桼ե򰷤
******************************************************************************/

#include <stdio.h>
#include <string.h>		/* strcmp, strcpy */
#include <stdlib.h>		/* atoi */
#include <limits.h>		/* INT_MAX */
#include "tx.h"

void Score_read(FILE*);
void Score_usrfread(FILE*);

static int input(char* msg, int lim, char* buf);

/******************************************************************************
ڴؿ̾	Score_init
ڵǽ	桼ե롢ե뤬ʤк롣ɤ߽Ф
ڰ	ʤ
͡	ʤ
******************************************************************************/
void Score_init(void) {
	int i;
	FILE* in;

	if ((in = fopen(usrfname, "r")) == NULL) {	/* 桼ե뤬ʤ */
		do {
			if (input("ʤ̾ϤƤ.", 8, usrname)) {
				ending("ޤθѤ򿴤餪ԤƤޤ.", NULL);
			}
		} while (!strcmp(usrname, "        "));	/* 桼̾줵 */
		lessonnum = 1;							/* ݤֹϽ 1 */
		Score_usrfwrite();						/* 񤭹 */
	} else {									/* 桼ե뤬 */
		Score_usrfread(in);						/* ɤ߽Ф */
		fclose(in);								/* ɤ饯 */
	}

	if ((in = fopen(scrfname, "r")) == NULL) {	/* ե뤬ʤ */
		Score_create();							/*  */
	} else {									/*  */
		Score_read(in);							/* ɤ߽Ф */
		fclose(in);								/* ɤ饯 */
	}


	for (i = 0; i < MAXSCORELIN; i++) {			/* ʬΥ */
		scr[i][0] = '\0';						/* ʸǽ */
	}
} /* Score_init */


/******************************************************************************
ڴؿ̾	Score_usrfread
ڵǽ	桼ե뤫ɤ߽Ф
ڰ	FILE ؤΥݥ󥿡
͡	ʤ
******************************************************************************/
void Score_usrfread(FILE* in) {
	int i;
	char buf[128+1];	/* ʬĹʤĤ */
	char buf2[1+MAXLESSONNUM+1];

	myfgets(buf, 128, in);
	if (strcmp(buf, USERFILEID)) {
		ending("%sפϥ桼եǤϤޤ.", usrfname);
	}

	if (myfgets(buf, 128, in) != 8) {
		ending("桼ե%sפǤΡ桼̾Ĺޤ.",
				usrfname);
	}
	strcpy(usrname, buf);

	myfgets(buf, 128, in);				/* Ǹˤäåֹ */
	lessonnum = atoi(buf);

	/*	ʲǸɤ߽Фơߤ٤롣Ūϡ
	 *	פäƤȤθ򤵤ʤǤ롣
	 */

	{
		time_t now;
		struct tm* tp;
		char tmpstr[2][20];

		/* 1999-12-24 02:34:56 η 19+1 Хȡ(+1 for '\0') */

		fgets(tmpstr[0], 20, in);
													/* Ǹ */
		tmpstr[0][19] = '\0';

		time(&now);

/*		tp = gmtime(&now); */						/* ߤ (UTC) */
		tp = localtime(&now);						/* ߤ (local) */

		sprintf(tmpstr[1], "19%02d-%02d-%02d %02d:%02d:%02d",
			tp->tm_year, tp->tm_mon + 1, tp->tm_mday,
			tp->tm_hour, tp->tm_min, tp->tm_sec);

		if (strcmp(tmpstr[0], tmpstr[1]) > 0) {
			ending("ԥ塼Υåޤ.", NULL);
		}
			/* ʸˤƤ٤ʤơѤäƤȻפޤ */
	}

	i = 1;
	{
		char c;						/* ʺѤɤʸɤ߹ */

		while ((c = fgetc(in)) != EOF) {
			if (c == '\n') {
				continue;
			} else {
				buf2[i++] = c;
				if (i > lastlessonnum) {
					break;
				}
			}
		}
	}
	buf2[i] = '\0';

	fgetc(in);								/* Ԥɤ߼Τ */

	for (i = 0; i < 8; i++) {				/* åɤ߹ */
		buf[i] = fgetc(in);
	}
	buf[8] = '\0';

	if (strtoul(buf, NULL, 16) != checksum(buf2 + 1, usrname)) {
		ending("\"%s\" ιʺѡ̤ʸ˰۾郎ȯޤ.",
				usrfname);
	}

	for (i = 1; i <= lastlessonnum; i++) {
		txtptr[i]->isclear = buf2[i];
	}

} /* Score_usrfread */


/******************************************************************************
ڴؿ̾	Score_usrfwrite
ڵǽ	桼եؤν񤭹ߡƤϼΤƤ롣
ڰ	ʤ
͡	ʤ
******************************************************************************/
int Score_usrfwrite(void) {
	FILE *fp;
	time_t now = time(NULL);
/*	struct tm* tmp = gmtime(&now);		*/
	struct tm* tmp = localtime(&now);
	char buf[1+MAXLESSONNUM+8+1];	/* ʺѡ̤ʡܥ桼̾ */
	int i;
	int retval = YES;

	chmod_to_777(usrfname);
	fp = fopen(usrfname, "w");
	if (fp == NULL) {
		ending("桼ե%sפץǤޤ.", usrfname);
	}

	if (fputs(USERFILEID, fp) == EOF
		|| fputc('\n', fp) == EOF
		|| fputs(usrname, fp) == EOF
		|| fputc('\n', fp) == EOF
		|| fprintf(fp, "%5d\n", lessonnum) < 0
		|| fprintf(fp, "%02d-%02d-%02d %02d:%02d:%02d\n",
				tmp->tm_year + 1900, tmp->tm_mon + 1, tmp->tm_mday,
				tmp->tm_hour, tmp->tm_min, tmp->tm_sec) < 0) {
		ending("桼ե%sפ˽񤭹ޤ.", usrfname);
	}

	for (i = 1; i <= lastlessonnum; i++) {	/* ʺѡ̤ʤʸˤ */
		buf[i] = txtptr[i]->isclear;
		if (buf[i] == 'x') {
			retval = NO;
		}
	}
	buf[i] = '\0';
	if (fprintf(fp, "%s\n", buf + 1) < 0) {		/*  */
		ending("桼ե%sפ˽񤭹ޤ.", usrfname);
	}

	if ((fprintf(fp, "%08lX\n", checksum(buf + 1, usrname)) < 0)
			|| (fclose(fp) == EOF)) {
		ending("桼ե%sפ˽񤭹ޤ.", usrfname);
	}
	chmod_to_755(usrfname);
	return retval;
} /* Score_usrfwrite */


/******************************************************************************
ڴؿ̾	Score_read
ڵǽ	եɤ߹ࡣ
ڰ	FILE ؤΥݥ󥿡
͡	ʤ
ա	ɤ߹ȤäƤ⡢̻Ҥȥ桼̾γǧǤ롣
******************************************************************************/
void Score_read(FILE *in) {
	char buf[128+1];

	myfgets(buf, 128+1, in);
	if (strcmp(buf, SCOREFILEID)) {
		ending("%sפϥեǤϤޤ.", scrfname);
	}

	myfgets(buf, 8+1, in);
	if (strcmp(buf, usrname)) {
		ending("桼եȥեδ֤ǡ桼̾äƤޤ.", NULL);
	}
} /* Score_read */


/******************************************************************************
ڴؿ̾	Score_create
ڵǽ	եο
ڰ	ʤ
͡	ʤ
******************************************************************************/
void Score_create(void) {
	FILE *out = fopen(scrfname, "w");

	if (out  == NULL) {
		ending("ե%sפޤ.", scrfname);
	}

	if (fputs(SCOREFILEID, out) == EOF
		|| fputc('\n', out) == EOF
		|| fprintf(out, "%s\n", usrname) < 0		/* 桼̾ */
		|| fclose(out) == EOF) {
		ending("ե%sפ˽񤭹ޤ.", scrfname);
	}
	chmod_to_755(scrfname);
} /* Score_create */


/******************************************************************************
ڴؿ̾	Score_write
ڵǽ	ե˽񤭹ࡣʲɽޤࡣ
ڰ	ʤ
͡	 ... OK, Բ ... NO.
ա	Ĺ顢и礷ɤǤ:-)
******************************************************************************/
int Score_write(void) {
	long tmp;
	int retval;
	char is_error_ok;
	char is_time_ok;
	Myfloat xx, yy, zz;
	char x[6], y[5], z[6];

		/* ÿ/ǿη׻ */

	if (seconds < 0 || your_strokes <= 0 || your_strokes > INT_MAX / 10
			|| seconds >= your_strokes * 10) {
		strcpy(x, "*.***");
	} else {
		Myfloat_init(&xx, seconds, your_strokes, 3);
		Myfloat_sprintf(x, xx);
	}

		/* 顼Ψη׻ */

	if (errors < 0 || errors * 100L < 0		/* errors * 100  INT_MAX  */
			|| your_strokes <= 0			/* ۤˤʤ뤫Τʤ */
			|| errors >= your_strokes) {	/* 顼Ψ 100 % ʾΤȤ */
		strcpy(y, "**.*");
		is_error_ok = '>';
	} else {
		long tmplong;

		Myfloat_init(&yy, errors * 100L, your_strokes, 1);
		Myfloat_sprintf(y, yy);
		tmplong = Myfloat_cmp(yy, errorlim);
		if (tmplong > 0) {
			is_error_ok = '>';
		} else if (tmplong == 0) {
			is_error_ok = '=';
		} else {
			is_error_ok = '<';
		}
	}

		/* ÿ/(ǿ-penalty*顼) η׻ */

	tmp = your_strokes - (long) penalty * errors;
			/* penalty  50  errors  800  40000 ˤʤΤ long */

	if (seconds < 0 || tmp <= 0 || tmp > INT_MAX / 10 || seconds >= tmp * 10) {
		strcpy(z, "*.***");
		is_time_ok = '>';
	} else {
		long tmplong;

		Myfloat_init(&zz, seconds, tmp, 3);
		Myfloat_sprintf(z, zz);
		tmplong = Myfloat_cmp(zz, timelim);
		if (tmplong > 0) {
			is_time_ok = '>';
		} else if (tmplong == 0) {
			is_time_ok = '=';
		} else {
			is_time_ok = '<';
		}
	}

	/*** ̤β˷̤ɽ ***/

	xgotoxy(LINES - 1, 1);
	xprintf("ǿ ǿ ÿ ÿ/ǿ 顼 顼Ψ(%%)  ÿ/(ǿ-%dx顼)", penalty);
	xclr2end();

	xgotoxy(LINES, 1);
	if (0 <= strokes && strokes < 1000) {
		xprintf("%4d", strokes);
	} else {
		xprintf(" ***");
	}
	if (0 <= your_strokes && your_strokes < 1000) {
		xprintf("%6d", your_strokes);
	} else {
		xprintf("   ***");
	}
	if (0 <= seconds && seconds < 1000) {
		xprintf("%5d", seconds);
	} else {
		xprintf("  ***");
	}
	xprintf("%10s", x);
	if (0 <= errors && errors < 1000) {
		xprintf("%10d", errors);
	} else {
		xprintf("       ***");
	}
	xprintf("%7s", y);
	xprintf(" %c ", is_error_ok);
	xprintf("%3s", str_errorlim);
	xprintf("%11s", z);
	xprintf(" %c ", is_time_ok);
	xprintf("%5s", str_timelim);
	xprintf("        ");

	if (is_error_ok == '>' || is_time_ok == '>') {
		retval = NO;
		xcolor4no();
		xprintf("Բ");
	} else {
		retval = OK;
		xcolor4ok();
		xprintf("");
	}
	xcolornormal();

	xclr2end();

	/*** ʲǥؤν񤭹 ***/

	if (scrfwrite == NO) {			/* scrfwrite ե饰ΩäƤʤ */
		return retval;				/* 񤭽Фʤǥ꥿ */
	}

	{
		int i;
		char st[80];				/* ʬ */
		time_t timer;
		struct tm *timeptr;
		FILE *out;

		chmod_to_777(scrfname);
		if ((out = fopen(scrfname, "a")) == NULL) {
			ending("ե%sפץǤޤ.", scrfname);
		}

		time(&timer);					/* μ */
		timeptr = localtime(&timer);	/* Ѵ */
			/* ե˵٤ʬst ˽񤭹 */
		sprintf(st,	"%-13s "			/* lessonname */
					"%02d-%02d-%02d "	/* ǯ */
					"%02d:%02d:%02d "	/* ʬ */
					"%3d"				/* lessonnum */
					"%4d%4d%4d "		/* strokes, your_strokes, seconds */
					"%s%4d %4s "		/* x, errors, y */
					"%s "				/* z */
					"%c",				/* 'o' ޤ 'x' */

				lessonname,
				timeptr->tm_year, timeptr->tm_mon + 1, timeptr->tm_mday,
				timeptr->tm_hour, timeptr->tm_min, timeptr->tm_sec,
				lessonnum,
				strokes, your_strokes, seconds,
				x, errors, y,
				z,
				retval ? 'o' : 'x'
		);

			/* ʬΥƬ˥ԡ */

		for (i = MAXSCORELIN - 2; i >= 0; i--) {
			strcpy(scr[i+1], scr[i]);
		}
		strcpy(scr[0], st);

			/* եؤν񤭹 */

		if (fprintf(out, "%s", st) == EOF) {
			ending("ե%sפ˽񤭹ޤ.", scrfname);
		}

			/* åη׻ */

		if (fprintf(out, " %08lX\n",
					checksum(st + MAXLESSONNAMELEN + 1, usrname)) == EOF
				|| fclose(out) == EOF ) {
			ending("ե%sפ˽񤭹ޤ.", scrfname);
		}
		chmod_to_755(scrfname);
	}
	return retval;
} /* Score_write */


/******************************************************************************
ڴؿ̾	input
ڵǽ	input.exe Ѥƥ桼Ϥ롣
ڰ	¥ʥåϤκĹϤγǼ衣
͡	0 ... OK, 1 ... NO.
ա	¥ʥåȾѥڡˤбƤʤ:-)
******************************************************************************/
static int input(char* msg, int lim, char* buf) {
	int c;
	FILE* in;
	char name[L_tmpnam];
	char cmdlin[128+1];		/* ǽʬĹ :-) */

	sprintf(cmdlin, "myinput %s %s %d", msg, tmpnam(name), lim);
	system(cmdlin);

	in = fopen(name, "rt");
	if (in == NULL) {
		return 1;
	}

	while ((c = fgetc(in)) != '\n') {
		*buf++ = c;
	}
	*buf = '\0';

	remove(name);

	return 0;
} /* input */
